Added new features to bldpkg

This commit is contained in:
PktSurf 2022-08-28 13:13:52 +05:30
parent 9f99df88eb
commit a488b78a7f

299
bldpkg
View file

@ -24,25 +24,19 @@
# in the test files and also add suitable bldpkg.conf switches for it
# -> Give a warning when more than two directories, a source and a staging directory
# not belonging to the current build are present inside tmpfs
# -> Temporarily create a directory defined as pkgdocs, where licenses go to $pkg/share/doc/<app-version>.
# At the end of the build, if $pkg/share/doc/<app> is created, move all the stuff contained in that
# directory into $pkg/share/doc/<app-version> and discard $pkg/share/doc/<app>
# -> Detect whether the build attempted to write anything outside /tmp. This can
# be accomplished via auditd. In the perfect world a sane build system would
# keep everything contained to the topmost build directory till DESTDIR is passed.
# But in the imperfect world, that is often not the case.
# # auditctl -l
# -w /bin -p w
# -w /lib -p w
# -w /share -p w
# -w /etc -p w
# -w /include -p w
# -w /usr -p w
# Above output watches for writes to /bin, /lib, /share, /etc, /include and /usr directories
# -> Write code to log build output to a log file inside a particular directory
# -> Write code to validate DISTCC_HOSTS variable
# -> Add code to provide -c option for pointing to an alternative bldpkg.conf file
# -> Add code to show extended help
# -> Add code to show extended help?
# -> Is 'set -e' really needed? Multiple exits are already in use...
# -> Often times it happens that there are two package build files, one
# being the original package build file that has been backed up and the
# package build file whose stuff such as source directory extraction and
# patches are commented out for testing and yet the build is initialised
# from this modified build file. Also, the package build file the build was invoked from
# gets copied in the resulting package installer for reference. We'd like the
# original package build file to be copied and not the modified package build
# file. Use -o <orig_bld_file> -m <modified_bld_file> for doing this, perhaps?
# -> Email the user about the outcome of the build?
# Begin subshell
(
@ -50,93 +44,15 @@
# Exit on any error
set -e
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below. This output goes
# into package build summary.
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below. This output goes into package build summary.
commencedate="$(date '+%a, %d %b %Y, %T')"
# Then source the configuration file holding all values
if [[ -f /etc/bldpkg.conf ]] ; then
source /etc/bldpkg.conf
else
echo "[ERROR] /etc/bldpkg.conf not found!"
exit 1
fi
# Store the source directory path the build was initiated from
srcdir="$PWD"
# Get relative directory name from SRCDIR
srcdirpath="$(basename $srcdir)"
buildfile="$srcdirpath.SMBuild"
# Function to source build file
sourcebuildfile() {
if [[ -f $buildfile ]] ; then
source "$buildfile"
else
# We expect a filename as part of -f argument
echo "[ERROR] No build file to source from!"
exit 1
fi
}
# Function to set buildfile if an argument is passed via getopts
setbuildfile() {
buildfile="$OPTARG"
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] Build file $buildfile not found!"
exit 1
fi
}
# Function to set number of make jobs, overrides those in bldpkg.conf
setcputhreads() {
cputhreads="$OPTARG"
# Validate if the argument is a number. If not, throw an error and exit.
if ! echo "$cputhreads" | egrep -q '^[0-9]+$' ; then
echo "[ERROR] Invalid CPU job number. Please try again."
exit 1
fi
}
# Generate sha512sums in the build file
genchecksum() {
echo "[INFO] Discarding old sha512sums from $buildfile"
tempbuildfile="$buildfile"
sed -E -i \
-e '/^sha512sums=".*"$/d' \
-e '/^sha512sums="/,/"$/d' \
-e "/^sha512sums='.*'\$/d" \
"$buildfile"
echo "[INFO] Adding new sha512sums in $tempbuildfile"
printf 'sha512sums="\n' >> "$tempbuildfile"
# Checksum digest to be used along with arguments
checksumbinary="sha512sum"
# File types whose checksums will go into the new build file
files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
# For loop that searches for files matching the above extension
# and prints them to the bottom of the build file
for file in ${files[@]} ; do
if [[ -f $file ]] ; then
$checksumbinary $file >> "$tempbuildfile"
fi
done
printf '"' >> "$tempbuildfile"
echo "[INFO] You may now run bldpkg again"
exit 0
}
# Function to generate help message
help() {
cat << EOF
Bash script for building SMLinux-compatible packages from source.
Any option used as an argument with this script overrides the
corresponding option, if present, in /etc/bldpkg.conf
corresponding option, if present, in /etc/bldpkg.conf or "'$HOME/.bldpkg.conf'"
If no arguments are provided, this script attempts to build a package
by matching the parent directory name with a build file that matches
@ -157,14 +73,14 @@ Building package 'alsa-lib' version '1.x' build '1sml'...
...build output...
Usage:
-d : Produce a package with debug symbols preserved
-d : Produce a package with debug symbols preserved. Uses -g3 by default.
-e : Extract the package installer file in the user's PWD if the build
completes successfully.
-f : Alternate build file to source build variables.
NOTE: This argument, if used, must come before any other argument
-f : Name of an alternate build file to source build variables. Should be
compatible with standard SMLinux package build file format.
-g : Generate SHA512 checksums of all tarballs and patches and insert them
into the package build file
@ -179,32 +95,129 @@ Usage:
-x : Invoke bash shell command trace mode. This one isn't akin to running
bash -x <script> but close enough, because the mode is inserted
half way while bldpkg is running
EOF
exit 0
}
# Then source the configuration file holding all values
if [[ -f $HOME/.bldpkg.conf ]] ; then
source "$HOME/.bldpkg.conf"
elif [[ -f /etc/bldpkg.conf ]] ; then
source /etc/bldpkg.conf
else
echo "[ERROR] /etc/bldpkg.conf not found!"
exit 1
fi
# Store the source directory path the build was initiated from
srcdir="$PWD"
# Get relative directory name from SRCDIR
srcdirpath="$(basename $srcdir)"
buildfile="$srcdirpath.SMBuild"
# Generate sha512sums in the build file
genchecksum() {
# Checksum digest to be used along with arguments
checksumbinary="/bin/sha512sum"
# Check if the binary exists
if [[ ! -x $checksumbinary ]] ; then
echo "[ERROR] $checksumbinary does not exist!"
fi
# File types whose checksums will go into the new build file
echo "[INFO] Discarding old sha512sums from $buildfile"
tempbuildfile="$buildfile"
sed -E -i \
-e '/^sha512sums=".*"$/d' \
-e '/^sha512sums="/,/"$/d' \
-e "/^sha512sums='.*'\$/d" \
"$buildfile"
echo "[INFO] Adding new sha512sums in $tempbuildfile"
printf 'sha512sums="\n' >> "$tempbuildfile"
files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
# For loop that searches for files matching the above extension
# and prints them to the bottom of the build file
for file in ${files[@]} ; do
if [[ -f $file ]] ; then
$checksumbinary $file >> "$tempbuildfile"
fi
done
printf '"' >> "$tempbuildfile"
echo "[INFO] You may now run bldpkg again"
exit 0
}
# Function for providing handy arguments to users. Some will override bldpkg.conf.
while getopts ':def:ghj:sx' option; do
case "$option" in
d) debug=1 ;; # Produce a debug build with -g3
e) extractprompt=0; autoextract=1 ;; # Automatically extract the final pkg installer inside user's PWD
f) setbuildfile "$OPTARG" ;;
e) extractprompt=0;
autoextract=1 ;; # Automatically extract the final pkg installer inside user's PWD
f) setbuildfile="$OPTARG" ;;
g) genchecksum ;;
h) help ;;
j) setcputhreads "$OPTARG" ;;
j) customcputhreads="$OPTARG" ;;
s) showsummary=1 ;; # Show build summary at the end of the build irrespective of the build status
x) set -xv ;; # Invoke bash's -x option for command tracing
*) help ;;
esac
done
# If no argument is given, or if argument is greater than 1, invoke sourcebuildfile function.
if [[ $OPTIND -ge 1 ]] ; then
sourcebuildfile
# The getopts builtin sets the OPTIND environment variable whose value is set to 1 if no argument is given. For every
# argument passed, the number is incremented by 1. In our case, if OPTIND equals 1, no argument was passed. We therefore expect
# a package build file to be present which will be then sourced.
if [[ $OPTIND = 1 ]] ; then
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] No package build file to source from!"
echo "[ERROR] Was expecting $buildfile to be present in your pwd."
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
else
source $buildfile
fi
# If OPTIND is greater than 1, check if a build file matching the parent directory exists, and if it does, source it.
elif [[ $OPTIND -gt 1 ]] ; then
# Override cputhreads sourced from bldpkg.conf if customcputhreads is set
if [[ -n $customcputhreads ]] ; then
cputhreads="$customcputhreads"
fi
# And validate whether the value is a number
if ! echo "$cputhreads" | sed 's@-j@@' | egrep -q '^[0-9]+$' ; then
echo "[ERROR] Invalid CPU job number. Please try again."
exit 1
fi
# If the original predetermined $buildfile is set, source it
if [[ -f $buildfile ]] ; then
source $buildfile
# If that is not the case, then check if $setbuildfile is set and is a file. If it is not a file, then return an error.
elif [[ ! -f $buildfile ]] ; then
if [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
echo "[ERROR] $setbuildfile not found!"
exit 1
# If $setbuildfile is set and is a file, source that file, else return an error an exit
elif [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
buildfile="$setbuildfile"
source $buildfile
else
echo "[ERROR] No package build file to source from!"
echo "[ERROR] Was expecting $buildfile to be present in your pwd."
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
fi
fi
fi
# Determine whether we are using bash version 4 and later
# Determine whether we are using bash version 4 and later. If not, exit.
if ((BASH_VERSINFO[0] < 4)) ; then
echo "[ERROR] bldpkg requires a minimum of bash shell version 4 to run"
exit 1
@ -241,7 +254,7 @@ if ! echo "$homepage" | egrep -q '^http://|^https://|^ftp://' ; then
exit 1
fi
# Validate $download
# Validate $download, first the URL type
if [[ -n $download ]]; then
if ! echo "$download" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'download'"' variable in the build file."
@ -249,12 +262,13 @@ if [[ -n $download ]]; then
fi
fi
# Then check for single quotes
if egrep -q "download='*'" "$buildfile" ; then
echo "Please dont use single quotes to define the download variable"
echo "[ERROR] Single quotes disallowed in the download variable"
exit 1
fi
# Validate $desc
# Validate $desc using bash shell's ability to count variable length
if [[ ${#desc} -gt 100 ]] ; then
echo "[ERROR] Package description should not exceed 100 characters in the build file."
exit 1
@ -272,17 +286,23 @@ sleep 0.5
# Invoke auditd if useauditd is set to 1 in bldpkg.conf
if [[ $useauditd = 1 ]] ; then
if [[ ! -x /bin/auditd ]] ; then
echo "[ERROR] Auditd not found!"
fi
# First clear out the log file
auditlogfile="/var/log/audit/audit.log"
echo > $auditlogfile
# Now run auditd. Ampersand is needed to log the PID.
# Now run auditd
/bin/auditd -n &
# Store the PID inside a variable
auditpid=$!
# Note: auditd writes 8 lines for our setup when initialized.
# Note: auditd writes about 6-8 lines for our setup when initialized.
echo "[INFO] Auditd initialised."
fi
# Function to safely terminate auditd.
terminateauditd() {
if [[ $useauditd = 1 ]] ; then
# Terminate auditd, log number of lines inside a variable
@ -298,7 +318,7 @@ terminateauditd() {
fi
}
# Now we attempt to split the total time we'll get when making the summary into two times: compile time and
# Now we attempt to split the total time we'll get when making the summary into two times: compile time and
# Only verify source checksums if skipchecksum is not set in the build file
if [[ -z $skipchecksum ]] ; then
if [[ -z $sha512sums ]] ; then
@ -320,8 +340,7 @@ if [[ -z $skipchecksum ]] ; then
unset IFS
fi
# Function to output to the user which patch is about to be applied. Useful when
# there are many patches and you want to determine which patch failed.
# Function to output to the user which patch is about to be applied. Useful when there are many patches and you want to determine which patch failed.
applypatch() {
if [[ -z $1 ]]; then
echo "[ERROR] Please provide valid patch file name"
@ -332,7 +351,7 @@ applypatch() {
patch -p1 < "$1"
}
# Do a preliminary package dependency check if checkdependencies is set to 1 in bldpkg.conf
# Do a preliminary package dependency check if $checkdependencies is set to 1 in bldpkg.conf
if [[ $checkdependencies = 1 ]] ; then
echo "[INFO] Parsing $app 's dependency list..."
@ -354,8 +373,8 @@ if [[ $checkdependencies = 1 ]] ; then
fi
# Function to specifically match arrays inside a value. This function will be used later on to perform package
# and directory matches using certain conditions. Note: "${ARRAY[@]}" =~ "${VARIABLE}" isn't fool-proof.
# Function to specifically match arrays inside a value. This function will be used later on to perform package and directory
# matches using certain conditions. Note: "${ARRAY[@]}" =~ "${VARIABLE}" isn't fool-proof.
inarray() {
local n=$1 h
shift
@ -377,7 +396,7 @@ fi
# Attempt to write to the $parenttmp directory. This directory is used for everything related to the build process outside #the source directory $srcdir
if ! touch "$parenttmp"/.smlinuxwritetest ; then
echo "[ERROR] $parenttmp is not writable."
echo "[ERROR] $parenttmp is not writable!"
exit 1
fi
@ -391,7 +410,7 @@ if inarray "${parenttmp}" "${protecteddirectories[@]}" ; then
exit 1
fi
# If $htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
# If htmloutput is set to 1, echo $app, $version and $build as file names inside the parent build directory.
# This will output into an HTML file so that the basic status of the build process (whether started, stopped,
# interrupted or failed) can be viewed in the web browser.
if [[ $htmloutput = 1 ]] ; then
@ -416,8 +435,8 @@ if ! inarray "${pkgext}" "${validpkgextensions[@]}" ; then
exit 1
fi
# Figure out the compression tool to be used based on the $pkgext variable set in bldpkg.conf. At the same time,
# export the compressor options set for makepkg to import from the build environment.
# Figure out the compression tool to be used based on the $pkgext variable set in bldpkg.conf. At the same time, export the compressor
# options set for makepkg to import from the build environment.
case "$pkgext" in
tgz) compressor=gzip
compressopts="$gzipopts"
@ -439,8 +458,7 @@ if ! $compressor --help > /dev/null 2>&1 ; then
exit 1
fi
# Validate the TMPFS directory. If usetmpfs is set to 1 and tmpfsdir variable is set, then check for
# genuineness of the TMPFS directory. If it fails, declare a variable for the build summary.
# Validate the TMPFS directory if usetmpfs is set to 1 and tmpfsdir variable is set. If it fails, declare a variable for the build summary.
if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]]; then
if [[ ! -d $tmpfsdir ]] || ! touch "$tmpfsdir/.smlinuxtmpwritetest" \
|| [[ "$(findmnt -no TARGET $tmpfsdir)" != "$tmpfsdir" ]] \
@ -470,15 +488,16 @@ if [[ $swapcheck = 1 ]]; then
fi
fi
# Set the temporary directory for building the package. Also define package staging directory. This is where package
# files that get "installed" go into, for example 'make install DESTDIR=$pkg' or 'DESTDIR="$pkg" ninja install'.
# Set the temporary directory for building the package. Also define package staging directory. This is where package files that get
# "installed" go into, for example 'make install DESTDIR=$pkg' or 'DESTDIR="$pkg" ninja install'.
# If usetmpfs is set to 1, tmpfsdir is defined and tmpfscheckfailed variable is unset, determine if the
# $app is in the exception list and whether to build inside or outside the TMPFS directory.
# If usetmpfs is set to 1, tmpfsdir is defined and tmpfscheckfailed variable is unset, determine if the $app is in the exception
# list and whether to build inside or outside the TMPFS directory.
if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]] && [[ -z $tmpfscheckfailed ]] ; then
# If $app is in the TMPFS exception list inside /etc/bldpkg.conf, compile it *OUTSIDE* the TMPFS directory, i.e
# the non-TMPFS directory, else compile it *INSIDE* the TMPFS directory. This if/else is solely for deciding
# If $app is in the TMPFS exception list inside /etc/bldpkg.conf, compile
# it *OUTSIDE* the TMPFS directory, i.e the non-TMPFS directory, else compile
# it *INSIDE* the TMPFS directory. This if/else is solely for deciding
# whether $app is in the exception list or not.
if inarray "${app}" "${tmpfsexceptionlist[@]}" ; then
@ -489,7 +508,8 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]] && [[ -z $tmpfscheckfailed ]] ; the
tmp="$nontmpfsdir/$app.src"
pkg="${pkg:-$nontmpfsdir/package-$app}"
else
# We compile inside tmpfsdir. Set the tmpfsenabledforthispackage variable here to inform build summary function at the bottom
# We compile inside tmpfsdir. Set the tmpfsenabledforthispackage variable
# here to inform build summary function at the bottom
tmpfsenabledforthispackage=1
# Disable ccache
@ -499,7 +519,8 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]] && [[ -z $tmpfscheckfailed ]] ; the
preservebuilddir=0
preservepackagedir=0
# Get the directory from the tmpfsdir variable for extracting the source and set it as our build and staging directory
# Get the directory from the tmpfsdir variable for extracting the source and
# set it as our build and staging directory
tmp="$tmpfsdir/$app.src"
pkg="${pkg:-$tmpfsdir/package-$app}"
@ -924,7 +945,7 @@ removestaticlibs() {
find "$pkg" -name "*.a" -exec rm -fv {} \;
}
# Function to perform post-compile tasks:
# Function to perform post-compile tasks.
# To be invoked inside a package build file.
mkfinalpkg() {
@ -998,7 +1019,7 @@ EOF
find "$pkg" -type f -name "*.la" -delete
# Provide a copy of the package build file so that users know the build options that went into compiling the package
install -Dm 644 "$srcdir/$buildfile" "$pkgdocs/$app.SMBuild"
install -Dm 644 "$srcdir/$buildfile" "$pkgdocs/$buildfile"
# We don't want multiple directories for documentation. Detect if $pkg/share/doc/<app-name> was created.
# If it has been created, move its contents into $pkgdocs and discard the old doc directory.
@ -1009,9 +1030,8 @@ EOF
rmdir $pkg/share/doc/$app
fi
# Normally we'd expect some debug symbols in the newly-produced binaries.
# But that isn't always the case with some packages whose build systems
# strip objects before hand
# Normally we'd expect some debug symbols in the newly-produced binaries. But that isn't always the case with some
# packages whose build systems strip objects before hand
if [[ $debug = 1 ]] ; then
for file in \
$( find $pkg )
@ -1458,7 +1478,6 @@ interruptoutput() {
trap "prepbuildoutput" EXIT
trap "interruptoutput" INT
#build 2>&1 | tee log.txt
build
)